unit DemoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  PerfDataComp, StdCtrls, ExtCtrls, CheckLst, ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Timer1: TTimer;
    CheckBox1: TCheckBox;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    FPerfMonitor: TPerfDataComp;
    { Private declarations }
  public
    { Public declarations }
    property PerfMonitor : TPerfDataComp read FPerfMonitor write FPerfMonitor;
  end;

var
  Form1: TForm1;

implementation

uses
  PDH;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  PerfCounter : TPerfCounter;
begin
  FPerfMonitor := TPerfDataComp.Create (Self);
  FPerfMonitor.Name := 'PerfMon';

  FPerfMonitor.OutPut := Memo1.Lines;
  Memo1.Lines.Add(Application.Name);

    PerfCounter := FPerfMonitor.PerfQuery.AddCounter ('\Process(DemoProj)\% Processor Time', PDH_FMT_DOUBLE);
  PerfCounter := FPerfMonitor.PerfQuery.AddCounter ('\Process(DemoProj)\Thread Count', PDH_FMT_DOUBLE);
  PerfCounter := FPerfMonitor.PerfQuery.AddCounter ('\\MARK\Process(DemoProj)\Page Faults/sec', PDH_FMT_DOUBLE);

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FPerfMonitor.BrowseCounters;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  FPerfMonitor.Update;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Timer1.Enabled := CheckBox1.Checked;
end;

end.
