unit DemoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  PerfDataComp, StdCtrls, ExtCtrls, CheckLst, ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;           // Exibe resultados
    Timer1: TTimer;         // Gera intervalo de refresh de tela
    CheckBox1: TCheckBox;   // Habilita e desabilita o timer
    Button1: TButton;       // Chama menu para exibir objetos e contadores
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    FPerfMonitor: TPerfDataComp;  // Componente para ler valores de Performance
    { Private declarations }
  public
    { Public declarations }
    property PerfMonitor : TPerfDataComp read FPerfMonitor write FPerfMonitor;
  end;

var
  Form1: TForm1;

implementation

uses
  PDH;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  PerfCounter : TPerfCounter;  // Define uma estrutura do tipo contador
begin
  FPerfMonitor := TPerfDataComp.Create (Self);  // Cria instncia do "componente"
  FPerfMonitor.Name := 'PerfMon';  // Define nome para o "componente"

  // Define uma estrutura do tipo Tstrings para receber sada
  FPerfMonitor.OutPut := Memo1.Lines;

  Memo1.Lines.Add(Application.Name); // Primeira linha: Nome do aplicativo
  // Seleciona os contadores a serem lidos atravs de seu path completo
  PerfCounter := FPerfMonitor.PerfQuery.AddCounter ('\Process(DemoProj)\% Processor Time', PDH_FMT_DOUBLE);
  PerfCounter := FPerfMonitor.PerfQuery.AddCounter ('\Process(DemoProj)\Thread Count', PDH_FMT_DOUBLE);
  PerfCounter := FPerfMonitor.PerfQuery.AddCounter ('\\MARK\Process(DemoProj)\Page Faults/sec', PDH_FMT_DOUBLE);
end;

procedure TForm1.Button1Click(Sender: TObject);
// Permite selecionar novos contadores
begin
  FPerfMonitor.BrowseCounters;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
// Update a cada Timer1.Interval (1000 ms)
begin
  // Chama a query a cada 1s. Os resultados sero impressos na janela pelo componente
  FPerfMonitor.Update;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
// Habilita ou desabilita o timer
begin
  Timer1.Enabled := CheckBox1.Checked;
end;


end.
