unit PDH;
{**************************************************************************}
{                                                                          }
{    This C DLL header file first (automatic) conversion generated by:     }
{    HeadConv 4.0 (c) 1999 by Bob Swart (aka Dr.Bob - www.drbob42.com)     }
{      FINAL DELPHI-JEDI COMMANDLINE EDITION                               }
{                                                                          }
{    Generated Date:     9/4/99                                            }
{    Generated Time: 5:06:57 PM                                              }
{                                                                          }
{**************************************************************************}

interface

uses
  SysUtils,
  Windows;

{=> D:\Ref\PDHDEMO\PDH.H <=}
{+//++ }
{-Copyright (C) 1996 Microsoft Corporation }
{-Module Name: }
{-PDH.H }
{-Abstract: }
{-Header file for the Performance Data Helper (PDH) DLL functions. }
{=-- }


const  // Cdigo dos erros retornados pelas funes PDH
   PDH_CSTATUS_VALID_DATA           = $00000000;
   PDH_CSTATUS_NEW_DATA             = $00000001;
   PDH_CSTATUS_NO_MACHINE           = $800007D0;
   PDH_CSTATUS_NO_INSTANCE          = $800007D1;
   PDH_MORE_DATA                    = $800007D2;
   PDH_CSTATUS_ITEM_NOT_VALIDATED   = $800007D3;
   PDH_RETRY                        = $800007D4;
   PDH_NO_DATA                      = $800007D5;
   PDH_CALC_NEGATIVE_DENOMINATOR    = $800007D6;
   PDH_CALC_NEGATIVE_TIMEBASE       = $800007D7;
   PDH_CALC_NEGATIVE_VALUE          = $800007D8;
   PDH_DIALOG_CANCELLED             = $800007D9;
   PDH_CSTATUS_NO_OBJECT            = $C0000BB8;
   PDH_CSTATUS_NO_COUNTER           = $C0000BB9;
   PDH_CSTATUS_INVALID_DATA         = $C0000BBA;
   PDH_MEMORY_ALLOCATION_FAILURE    = $C0000BBB;
   PDH_INVALID_HANDLE               = $C0000BBC;
   PDH_INVALID_ARGUMENT             = $C0000BBD;
   PDH_FUNCTION_NOT_FOUND           = $C0000BBE;
   PDH_CSTATUS_NO_COUNTERNAME       = $C0000BBF;
   PDH_CSTATUS_BAD_COUNTERNAME      = $C0000BC0;
   PDH_INVALID_BUFFER               = $C0000BC1;
   PDH_INSUFFICIENT_BUFFER          = $C0000BC2;
   PDH_CANNOT_CONNECT_MACHINE       = $C0000BC3;
   PDH_INVALID_PATH                 = $C0000BC4;
   PDH_INVALID_INSTANCE             = $C0000BC5;
   PDH_INVALID_DATA                 = $C0000BC6;
   PDH_NO_DIALOG_DATA               = $C0000BC7;
   PDH_CANNOT_READ_NAME_STRINGS     = $C0000BC8;


type
  EPDHError = class(Exception);

type
  PDH_STATUS = Longword	;
  PDH_FUNCTION = PDH_STATUS;

procedure PDHCheck (ReturnValue: PDH_FUNCTION);
function PDHErrorMessage (ErrorValue: PDH_FUNCTION) : string;
procedure PDHError (ErrorString : String);

{/// version info }
const
  PDH_CVERSION_WIN40 = $0400;
const
  PDH_VERSION = PDH_CVERSION_WIN40;

type
  HCOUNTER = THandle;
type
  HQUERY = THandle;

type   // Estrutura para receber o valor bruto de um contador
  _PDH_RAW_COUNTER = record
    CStatus: LongInt;
    TimeStamp: FILETIME;
    FirstValue: LONGLONG;
    SecondValue: LONGLONG;
    MultiCount: LongInt;
  end {_PDH_RAW_COUNTER};
  PDH_RAW_COUNTER = _PDH_RAW_COUNTER;
  PPDH_RAW_COUNTER = ^_PDH_RAW_COUNTER;

type   // Estrutura para receber o valor formatado de um contador
  _PDH_FMT_COUNTERVALUE = record
    CStatus: LongInt;
    longValue: LongInt;
    doubleValue: Double;
    largeValue: LONGLONG;
  end {_PDH_FMT_COUNTERVALUE};
  PDH_FMT_COUNTERVALUE = _PDH_FMT_COUNTERVALUE;
  PPDH_FMT_COUNTERVALUE = ^_PDH_FMT_COUNTERVALUE;

type
  _PDH_STATISTICS = record
    dwFormat: LongInt;
    count: LongInt;
    min: _PDH_FMT_COUNTERVALUE;
    max: _PDH_FMT_COUNTERVALUE;
    mean: _PDH_FMT_COUNTERVALUE;
  end {_PDH_STATISTICS};
  PDH_STATISTICS = _PDH_STATISTICS;
  PPDH_STATISTICS = ^_PDH_STATISTICS;

type
  _PDH_COUNTER_PATH_ELEMENTS_A = record
    szMachineName: PChar;
    szObjectName: PChar;
    szInstanceName: PChar;
    szParentInstance: PChar;
    dwInstanceIndex: LongInt;
    szCounterName: PChar;
  end {_PDH_COUNTER_PATH_ELEMENTS_A};
  PDH_COUNTER_PATH_ELEMENTS_A = _PDH_COUNTER_PATH_ELEMENTS_A;
  PPDH_COUNTER_PATH_ELEMENTS_A = ^_PDH_COUNTER_PATH_ELEMENTS_A;

type
  _PDH_COUNTER_PATH_ELEMENTS_W = record
    szMachineName: PWideChar;
    szObjectName: PWideChar;
    szInstanceName: PWideChar;
    szParentInstance: PWideChar;
    dwInstanceIndex: LongInt;
    szCounterName: PWideChar;
  end {_PDH_COUNTER_PATH_ELEMENTS_W};
  PDH_COUNTER_PATH_ELEMENTS_W = _PDH_COUNTER_PATH_ELEMENTS_W;
  PPDH_COUNTER_PATH_ELEMENTS_W = ^_PDH_COUNTER_PATH_ELEMENTS_W;

type
  _PDH_COUNTER_INFO_A = record
    dwLength: LongInt;
    dwType: LongInt;
    CVersion: LongInt;
    CStatus: LongInt;
    lScale: LongInt;
    lDefaultScale: LongInt;
    dwUserData: LongInt;
    dwQueryUserData: LongInt;
    szFullPath: PChar;
        CounterPath: PDH_COUNTER_PATH_ELEMENTS_A;
        szMachineName: PChar;
    szObjectName: PChar;
    szInstanceName: PChar;
    szParentInstance: PChar;
    dwInstanceIndex: LongInt;
    szCounterName: PChar;
  end {_PDH_COUNTER_INFO_A};

type
  _PDH_COUNTER_INFO_W = record
    dwLength: LongInt;
    dwType: LongInt;
    CVersion: LongInt;
    CStatus: LongInt;
    lScale: LongInt;
    lDefaultScale: LongInt;
    dwUserData: LongInt;
    dwQueryUserData: LongInt;
    szFullPath: PWideChar;
        CounterPath: PDH_COUNTER_PATH_ELEMENTS_W;
        szMachineName: PWideChar;
    szObjectName: PWideChar;
    szInstanceName: PWideChar;
    szParentInstance: PWideChar;
    dwInstanceIndex: LongInt;
    szCounterName: PWideChar;
  end {_PDH_COUNTER_INFO_W};

{/// function definitions }

type
  LPVOID = pointer;

  var
    PdhGetDllVersion : function (lpdwVersion: LPDWORD): Longint cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

{/// }
{/// Query Functions }
{/// }

  PdhOpenQuery : function (pReserved: LPVOID;
                         dwUserData:DWORD;
                         var phQuery: HQUERY): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhAddCounterW : function (hQuery: HQUERY;
                           szFullCounterPath: LPCWSTR;
                           dwUserData: DWORD;
                           var phCounter: HCOUNTER): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhAddCounterA : function (hQuery: HQUERY;
                           szFullCounterPath: LPCSTR;
                           dwUserData: DWORD;
                           var phCounter: HCOUNTER): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhRemoveCounter: function (hCounter: HCOUNTER): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhCollectQueryData: function (hQuery: HQUERY): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhCloseQuery: function (hQuery: HQUERY): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

{/// }
{/// Counter Functions }
{/// }

  PdhGetFormattedCounterValue: function (hCounter: HCOUNTER;
                                        dwFormat: DWORD;
                                        lpdwType: LPDWORD;
                                        var pValue: _PDH_FMT_COUNTERVALUE): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

{/// dwFormat flag values }
{/// }
const
  PDH_FMT_RAW = $00000010;
  PDH_FMT_ANSI = $00000020;
  PDH_FMT_UNICODE = $00000040;
  PDH_FMT_LONG = $00000100;
  PDH_FMT_DOUBLE = $00000200;
  PDH_FMT_LARGE = $00000400;
  PDH_FMT_NOSCALE = $00001000;
  PDH_FMT_1000 = $00002000;
  PDH_FMT_NODATA = $00004000;

var
  PdhGetRawCounterValue : function (hCounter: HCOUNTER;
                                  lpdwType: LPDWORD;
                                  pValue: PPDH_RAW_COUNTER): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhCalculateCounterFromRawValue: function (hCounter: HCOUNTER;
                                            dwFormat: DWORD;
                                            rawValue1: PPDH_RAW_COUNTER;
                                            rawValue2: PPDH_RAW_COUNTER;
                                            fmtValue: _PDH_FMT_COUNTERVALUE): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhComputeCounterStatistics: function (hCounter: HCOUNTER;
                                        dwFormat: DWORD;
                                        dwFirstEntry: DWORD;
                                        dwNumEntries: DWORD;
                                        lpRawValueArray: _PDH_RAW_COUNTER;
                                        data: _PDH_STATISTICS): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhGetCounterInfoW: function (hCounter: HCOUNTER;
                               bRetrieveExplainText: BOOLEAN;
                               pdwBufferSize: LPDWORD;
                               lpBuffer: _PDH_COUNTER_INFO_W): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhGetCounterInfoA: function (hCounter: HCOUNTER;
                               bRetrieveExplainText: BOOLEAN;
                               pdwBufferSize: LPDWORD;
                               lpBuffer: _PDH_COUNTER_INFO_A): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

const
  PDH_MAX_SCALE = (7);
const
  PDH_MIN_SCALE = (-7);

var
  PdhSetCounterScaleFactor: function  (hCounter: HCOUNTER;
                                     lFactor: Longword): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};
{/// }
{/// Browsing and enumeration functions }
{/// }
  PdhConnectMachineW : function (szMachineName: LPCWSTR): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhConnectMachineA: function (szMachineName: LPCSTR): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhEnumMachinesW : function (szReserved: LPCWSTR;
                             mszMachineList: LPWSTR;
                             pcchBufferSize: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhEnumMachinesA: function (szReserved: LPCSTR;
                             mszMachineList: LPSTR;
                             pcchBufferSize: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhEnumObjectsW: function  (szReserved: LPCWSTR;
                            szMachineName: LPCWSTR;
                            mszObjectList: LPWSTR;
                            pcchBufferSize: LPDWORD;
                            dwDetailLevel: DWORD;
                            bRefresh: BOOL): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhEnumObjectsA: function  (szReserved: LPCSTR;
                            szMachineName: LPCSTR;
                            mszObjectList: LPSTR;
                            pcchBufferSize: LPDWORD;
                            dwDetailLevel: DWORD;
                            bRefresh: BOOL): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

   PdhEnumObjectItemsW : function (szReserved: LPCWSTR;
                                szMachineName: LPCWSTR;
                                szObjectName: LPCWSTR;
                                mszCounterList: LPWSTR;
                                pcchCounterListLength: LPDWORD;
                                mszInstanceList: LPWSTR;
                                pcchInstanceListLength: LPDWORD;
                                dwDetailLevel: DWORD) : PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

   PdhEnumObjectItemsA : function (szReserved: LPCSTR;
                                szMachineName: LPCSTR;
                                szObjectName: LPCSTR;
                                mszCounterList: LPSTR;
                                pcchCounterListLength: LPDWORD;
                                mszInstanceList: LPSTR;
                                pcchInstanceListLength: LPDWORD;
                                dwDetailLevel: DWORD;
                                flags :DWORD)  : PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhMakeCounterPathW: function  (var pCounterPathElements: PDH_COUNTER_PATH_ELEMENTS_W;
                                szFullPathBuffer: LPWSTR;
                                pcchBufferSize: LPDWORD;
                                dwFlags: DWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhMakeCounterPathA: function  (var pCounterPathElements: PDH_COUNTER_PATH_ELEMENTS_A;
                                szFullPathBuffer: LPSTR;
                                pcchBufferSize: LPDWORD;
                                dwFlags: DWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhParseCounterPathW: function (szFullPathBuffer: LPCWSTR;
                                 var pCounterPathElements: PDH_COUNTER_PATH_ELEMENTS_W;
                                 pdwBufferSize: LPDWORD;
                                 dwFlags:DWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhParseCounterPathA: function (szFullPathBuffer: LPCSTR;
                                 var pCounterPathElements: PDH_COUNTER_PATH_ELEMENTS_A;
                                 pdwBufferSize: LPDWORD;
                                 dwFlags: DWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

 PdhParseInstanceNameW: function (szInstanceString: LPCWSTR;
                                  szInstanceName: LPWSTR;
                                  pcchInstanceNameLength: LPDWORD;
                                  szParentName: LPWSTR;
                                  pcchParentNameLength: LPDWORD;
                                  lpIndex: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhParseInstanceNameA: function (szInstanceString: LPCSTR;
                                  szInstanceName: LPSTR;
                                  pcchInstanceNameLength: LPDWORD;
                                  szParentName: LPSTR;
                                  pcchParentNameLength: LPDWORD;
                                  lpIndex: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhValidatePathW: function (szFullPathBuffer: LPCWSTR): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhValidatePathA: function (szFullPathBuffer: LPCSTR): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhGetDefaultPerfObjectW: function (szReserved: LPCWSTR;
                                     szMachineName: LPCWSTR;
                                     szDefaultObjectName: LPWSTR;
                                     pcchBufferSize: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};


 PdhGetDefaultPerfObjectA: function (szReserved: LPCSTR;
                                     szMachineName: LPCSTR;
                                     szDefaultObjectName: LPSTR;
                                     pcchBufferSize: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

PdhGetDefaultPerfCounterW : function (szReserved: LPCWSTR;
                                      szMachineName: LPCWSTR;
                                      szObjectName: LPCWSTR;
                                      szDefaultCounterName: LPWSTR; 
                                      pcchBufferSize: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};


  PdhGetDefaultPerfCounterA : function (szReserved: LPCSTR;
                                      szMachineName: LPCSTR;
                                      szObjectName: LPCSTR;
                                      szDefaultCounterName: LPSTR;
                                      pcchBufferSize: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

type
  CounterPathCallBack = function {(Arg : DWORD)} : PDH_STATUS; stdcall;

type

{$Z4+}
  TPDHDlgFlagsEnum = (bIncludeInstanceIndex,
                  bSingleCounterPerAdd,
                  bSingleCounterPerDialog,
                  bLocalCountersOnly,
                  bWildCardInstances,
                  bHideDetailBox,
                  bInitializePath,
                  bDisableMachineSelection);
  TPDHDlgFlags = set of TPDHDlgFlagsEnum;
{$Z4-}

  _BrowseDlgConfig_W = record
{/// Configuration flags }
  flags : TPDHDlgFlags;
{    bIncludeInstanceIndex:1,
    bSingleCounterPerAdd:1,
    bSingleCounterPerDialog:1,
    bLocalCountersOnly:1,
    bWildCardInstances:1,
    bHideDetailBox:1,
    bInitializePath:1,
    bDisableMachineSelection:1,
    bReserved:24: LongInt;
    }
    hWndOwner: HWND;
    szReserved: PWideChar;
    szReturnPathBuffer: PWideChar;
    cchReturnPathLength: LongInt;
    pCallBack: COUNTERPATHCALLBACK;
    dwCallBackArg: LongInt;
    CallBackStatus: PDH_STATUS;
    dwDefaultDetailLevel: LongInt;
    szDialogBoxCaption: PWideChar;
  end {_BrowseDlgConfig_W};
  PDH_BROWSE_DLG_CONFIG_W = _BrowseDlgConfig_W;
  PPDH_BROWSE_DLG_CONFIG_W = ^_BrowseDlgConfig_W;

type
  _BrowseDlgConfig_A = record
  flags : TPDHDlgFlags;
    hWndOwner: HWND;
    szReserved: PChar;
    szReturnPathBuffer: PChar;
    cchReturnPathLength: LongInt;
    pCallBack: COUNTERPATHCALLBACK;
    dwCallBackArg: LongInt;
    CallBackStatus: PDH_STATUS;
    dwDefaultDetailLevel: LongInt;
    szDialogBoxCaption: PChar;
  end {_BrowseDlgConfig_A};
  PDH_BROWSE_DLG_CONFIG_A = _BrowseDlgConfig_A;
  PPDH_BROWSE_DLG_CONFIG_A = ^_BrowseDlgConfig_A;
var
  PdhBrowseCountersW: function (pBrowseDlgData: PPDH_BROWSE_DLG_CONFIG_W): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhBrowseCountersA: function (pBrowseDlgData: PPDH_BROWSE_DLG_CONFIG_A): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhExpandCounterPathW: function (szWildCardPath: LPCWSTR;
                                  mszExpandedPathList: LPWSTR;
                                  pcchPathListLength: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

  PdhExpandCounterPathA: function (szWildCardPath: LPCSTR;
                                  mszExpandedPathList: LPSTR;
                                  pcchPathListLength: LPDWORD): PDH_FUNCTION cdecl  {$IFDEF WIN32} stdcall {$ENDIF};

{$IFDEF UNICODE}

const      // COostantes para uso com UNICODE (Wide Strings)
  PdhAddCounter = PdhAddCounterW;
  PdhGetCounterInfo = PdhGetCounterInfoW;
  PDH_COUNTER_INFO = PDH_COUNTER_INFO_W;
  PPDH_COUNTER_INFO = PPDH_COUNTER_INFO_W;
  PdhConnectMachine = PdhConnectMachineW;
  PdhEnumMachines = PdhEnumMachinesW;
  PdhEnumObjects = PdhEnumObjectsW;
  PdhEnumObjectItems = PdhEnumObjectItemsW;
  PdhMakeCounterPath = PdhMakeCounterPathW;
  PDH_COUNTER_PATH_ELEMENTS = PDH_COUNTER_PATH_ELEMENTS_W;
  PPDH_COUNTER_PATH_ELEMENTS = PPDH_COUNTER_PATH_ELEMENTS_W;
  PdhParseCounterPath = PdhParseCounterPathW;
  PdhParseInstanceName = PdhParseInstanceNameW;
  PdhValidatePath = PdhValidatePathW;
  PdhGetDefaultPerfObject = PdhGetDefaultPerfObjectW;
  PdhGetDefaultPerfCounter = PdhGetDefaultPerfCounterW;
  PdhBrowseCounters = PdhBrowseCountersW;
  PDH_BROWSE_DLG_CONFIG = PDH_BROWSE_DLG_CONFIG_W;
  PPDH_BROWSE_DLG_CONFIG = PPDH_BROWSE_DLG_CONFIG_W;
  PdhExpandCounterPath = PdhExpandCounterPathW;
{$ELSE}
{const            // Constantes para uso com strings ANSI
  PdhAddCounter = PdhAddCounterA;
  PdhGetCounterInfo = PdhGetCounterInfoA;
  PDH_COUNTER_INFO = _PDH_COUNTER_INFO_A;
  PPDH_COUNTER_INFO = _PPDH_COUNTER_INFO_A;
  PdhConnectMachine = PdhConnectMachineA;
  PdhEnumMachines = PdhEnumMachinesA;
  PdhEnumObjects = PdhEnumObjectsA;
  PdhEnumObjectItems = PdhEnumObjectItemsA;
  PdhMakeCounterPath = PdhMakeCounterPathA;
  PDH_COUNTER_PATH_ELEMENTS = PDH_COUNTER_PATH_ELEMENTS_A;
  PPDH_COUNTER_PATH_ELEMENTS = PPDH_COUNTER_PATH_ELEMENTS_A;
  PdhParseCounterPath = PdhParseCounterPathA;
  PdhParseInstanceName = PdhParseInstanceNameA;
  PdhValidatePath = PdhValidatePathA;
  PdhGetDefaultPerfObject = PdhGetDefaultPerfObjectA;
  PdhGetDefaultPerfCounter = PdhGetDefaultPerfCounterA;
  PdhBrowseCounters = PdhBrowseCountersA;
  PDH_BROWSE_DLG_CONFIG = PDH_BROWSE_DLG_CONFIG_A;
  PPDH_BROWSE_DLG_CONFIG = PPDH_BROWSE_DLG_CONFIG_A;
  PdhExpandCounterPath = PdhExpandCounterPathA;
  }
{$ENDIF UNICODE}

var
  DLLLoaded: Boolean = False;

implementation

// Traduz o tipo de erro para um string
function PDHErrorMessage (ErrorValue: PDH_FUNCTION) : string;
begin
  case ErrorValue of
   PDH_CSTATUS_VALID_DATA           : Result := 'PDH_CSTATUS_VALID_DATA';
   PDH_CSTATUS_NEW_DATA             : Result := 'PDH_CSTATUS_NEW_DATA';
   PDH_CSTATUS_NO_MACHINE           : Result := 'PDH_CSTATUS_NO_MACHINE';
   PDH_CSTATUS_NO_INSTANCE          : Result := 'PDH_CSTATUS_NO_INSTANCE';
   PDH_MORE_DATA                    : Result := 'PDH_MORE_DATA';
   PDH_CSTATUS_ITEM_NOT_VALIDATED   : Result := 'PDH_CSTATUS_ITEM_NOT_VALIDATED';
   PDH_RETRY                        : Result := 'PDH_RETRY';
   PDH_NO_DATA                      : Result := 'PDH_NO_DATA';
   PDH_CALC_NEGATIVE_DENOMINATOR    : Result := 'PDH_CALC_NEGATIVE_DENOMINATOR';
   PDH_CALC_NEGATIVE_TIMEBASE       : Result := 'PDH_CALC_NEGATIVE_TIMEBASE';
   PDH_CALC_NEGATIVE_VALUE          : Result := 'PDH_CALC_NEGATIVE_VALUE';
   PDH_DIALOG_CANCELLED             : Result := 'PDH_DIALOG_CANCELLED';
   PDH_CSTATUS_NO_OBJECT            : Result := 'PDH_CSTATUS_NO_OBJECT';
   PDH_CSTATUS_NO_COUNTER           : Result := 'PDH_CSTATUS_NO_COUNTER';
   PDH_CSTATUS_INVALID_DATA         : Result := 'PDH_CSTATUS_INVALID_DATA';
   PDH_MEMORY_ALLOCATION_FAILURE    : Result := 'PDH_MEMORY_ALLOCATION_FAILURE';
   PDH_INVALID_HANDLE               : Result := 'PDH_INVALID_HANDLE';
   PDH_INVALID_ARGUMENT             : Result := 'PDH_INVALID_ARGUMENT';
   PDH_FUNCTION_NOT_FOUND           : Result := 'PDH_FUNCTION_NOT_FOUND';
   PDH_CSTATUS_NO_COUNTERNAME       : Result := 'PDH_CSTATUS_NO_COUNTERNAME';
   PDH_CSTATUS_BAD_COUNTERNAME      : Result := 'PDH_CSTATUS_BAD_COUNTERNAME';
   PDH_INVALID_BUFFER               : Result := 'PDH_INVALID_BUFFER';
   PDH_INSUFFICIENT_BUFFER          : Result := 'PDH_INSUFFICIENT_BUFFER';
   PDH_CANNOT_CONNECT_MACHINE       : Result := 'PDH_CANNOT_CONNECT_MACHINE';
   PDH_INVALID_PATH                 : Result := 'PDH_INVALID_PATH';
   PDH_INVALID_INSTANCE             : Result := 'PDH_INVALID_INSTANCE';
   PDH_INVALID_DATA                 : Result := 'PDH_INVALID_DATA';
   PDH_NO_DIALOG_DATA               : Result := 'PDH_NO_DIALOG_DATA';
   PDH_CANNOT_READ_NAME_STRINGS     : Result := 'PDH_CANNOT_READ_NAME_STRINGS';
  else
    Result := 'Unknown PDH Error value' + IntToStr(ErrorValue);
  end;
end;

procedure PDHError (ErrorString : String);
begin
  raise EPDHError.Create('PDH Error: ' + ErrorString);
end;

procedure PDHCheck (ReturnValue: PDH_FUNCTION);
begin
  case ReturnValue of
   PDH_CSTATUS_VALID_DATA           :;
   PDH_CSTATUS_NEW_DATA             :;
   PDH_MORE_DATA                    :;
   PDH_DIALOG_CANCELLED             :;
   PDH_CSTATUS_NO_MACHINE,
   PDH_CSTATUS_NO_INSTANCE,
   PDH_CSTATUS_ITEM_NOT_VALIDATED,
   PDH_RETRY,
   PDH_NO_DATA,
   PDH_CALC_NEGATIVE_DENOMINATOR,
   PDH_CALC_NEGATIVE_TIMEBASE,
   PDH_CALC_NEGATIVE_VALUE,
   PDH_CSTATUS_NO_OBJECT,
   PDH_CSTATUS_NO_COUNTER,
   PDH_CSTATUS_INVALID_DATA,
   PDH_MEMORY_ALLOCATION_FAILURE,
   PDH_INVALID_HANDLE,
   PDH_INVALID_ARGUMENT,
   PDH_FUNCTION_NOT_FOUND,
   PDH_CSTATUS_NO_COUNTERNAME,
   PDH_CSTATUS_BAD_COUNTERNAME,
   PDH_INVALID_BUFFER,
   PDH_INSUFFICIENT_BUFFER,
   PDH_CANNOT_CONNECT_MACHINE,
   PDH_INVALID_PATH,
   PDH_INVALID_INSTANCE,
   PDH_INVALID_DATA,
   PDH_NO_DIALOG_DATA,
   PDH_CANNOT_READ_NAME_STRINGS : PDHError(PDHErrorMessage(ReturnValue));
  end;
end;



var
  SaveExit: pointer;
  DLLHandle: THandle;
  ErrorMode: Integer;

  procedure NewExit; far;
  begin
    ExitProc := SaveExit;
    FreeLibrary(DLLHandle)
  end {NewExit};

procedure LoadDLL;
begin
  if DLLLoaded then Exit;
  ErrorMode := SetErrorMode($8000{SEM_NoOpenFileErrorBox});
  DLLHandle := LoadLibrary('PDH.DLL');
  if DLLHandle >= 32 then
  begin
    DLLLoaded := True;
    SaveExit := ExitProc;
    ExitProc := @NewExit;
//    @@ := GetProcAddress(DLLHandle,'@');
  {$IFDEF WIN32}
//    Assert(@@ <> nil);
  {$ENDIF}
//    @@ := GetProcAddress(DLLHandle,'@');
  {$IFDEF WIN32}
//    Assert(@@ <> nil);
  {$ENDIF}
//    @@ := GetProcAddress(DLLHandle,'@');
  {$IFDEF WIN32}
//    Assert(@@ <> nil);
  {$ENDIF}
//    @@ := GetProcAddress(DLLHandle,'@');
  {$IFDEF WIN32}
//    Assert(@@ <> nil);
  {$ENDIF}

    @PdhGetDllVersion := GetProcAddress(DLLHandle,'PdhGetDllVersion');
    Assert(@PdhGetDllVersion <> nil);

    @PdhOpenQuery := GetProcAddress(DLLHandle,'PdhOpenQuery');
    Assert(@PdhOpenQuery <> nil);

    @PdhAddCounterW := GetProcAddress(DLLHandle,'PdhAddCounterW');
    Assert(@PdhAddCounterW <> nil);

    @PdhAddCounterA := GetProcAddress(DLLHandle,'PdhAddCounterA');
    Assert(@PdhAddCounterA <> nil);

    @PdhRemoveCounter := GetProcAddress(DLLHandle,'PdhRemoveCounter');
    Assert(@PdhRemoveCounter <> nil);

    @PdhCollectQueryData := GetProcAddress(DLLHandle,'PdhCollectQueryData');
    Assert(@PdhCollectQueryData <> nil);

    @PdhCloseQuery := GetProcAddress(DLLHandle,'PdhCloseQuery');
    Assert(@PdhCloseQuery <> nil);

    @PdhGetFormattedCounterValue := GetProcAddress(DLLHandle,'PdhGetFormattedCounterValue');
    Assert(@PdhGetFormattedCounterValue <> nil);

    @PdhGetRawCounterValue := GetProcAddress(DLLHandle,'PdhGetRawCounterValue');
    Assert(@PdhGetRawCounterValue <> nil);

    @PdhCalculateCounterFromRawValue := GetProcAddress(DLLHandle,'PdhCalculateCounterFromRawValue');
    Assert(@PdhCalculateCounterFromRawValue <> nil);

    @PdhComputeCounterStatistics := GetProcAddress(DLLHandle,'PdhComputeCounterStatistics');
    Assert(@PdhComputeCounterStatistics <> nil);

    @PdhGetCounterInfoW := GetProcAddress(DLLHandle,'PdhGetCounterInfoW');
    Assert(@PdhGetCounterInfoW <> nil);

    @PdhGetCounterInfoA := GetProcAddress(DLLHandle,'PdhGetCounterInfoA');
    Assert(@PdhGetCounterInfoA <> nil);

    @PdhSetCounterScaleFactor := GetProcAddress(DLLHandle,'PdhSetCounterScaleFactor');
    Assert(@PdhSetCounterScaleFactor <> nil);

    @PdhConnectMachineW := GetProcAddress(DLLHandle,'PdhConnectMachineW');
    Assert(@PdhConnectMachineW <> nil);

    @PdhConnectMachineA := GetProcAddress(DLLHandle,'PdhConnectMachineA');
    Assert(@PdhConnectMachineA <> nil);

    @PdhEnumMachinesW := GetProcAddress(DLLHandle,'PdhEnumMachinesW');
    Assert(@PdhEnumMachinesW <> nil);

    @PdhEnumMachinesA := GetProcAddress(DLLHandle,'PdhEnumMachinesA');
    Assert(@PdhEnumMachinesA <> nil);

    @PdhEnumObjectsW := GetProcAddress(DLLHandle,'PdhEnumObjectsW');
    Assert(@PdhEnumObjectsW <> nil);

    @PdhEnumObjectsA := GetProcAddress(DLLHandle,'PdhEnumObjectsA');
    Assert(@PdhEnumObjectsA <> nil);

    @PdhEnumObjectItemsW := GetProcAddress(DLLHandle,'PdhEnumObjectItemsW');
    Assert(@PdhEnumObjectItemsW <> nil);

    @PdhEnumObjectItemsA := GetProcAddress(DLLHandle,'PdhEnumObjectItemsA');
    Assert(@PdhEnumObjectItemsA <> nil);

    @PdhMakeCounterPathW := GetProcAddress(DLLHandle,'PdhMakeCounterPathW');
    Assert(@PdhMakeCounterPathW <> nil);

    @PdhMakeCounterPathA := GetProcAddress(DLLHandle,'PdhMakeCounterPathA');
    Assert(@PdhMakeCounterPathA <> nil);

    @PdhParseCounterPathW := GetProcAddress(DLLHandle,'PdhParseCounterPathW');
    Assert(@PdhParseCounterPathW <> nil);

    @PdhParseCounterPathA := GetProcAddress(DLLHandle,'PdhParseCounterPathA');
    Assert(@PdhParseCounterPathA <> nil);

    @PdhParseInstanceNameW := GetProcAddress(DLLHandle,'PdhParseInstanceNameW');
    Assert(@PdhParseInstanceNameW <> nil);

    @PdhParseInstanceNameA := GetProcAddress(DLLHandle,'PdhParseInstanceNameA');
    Assert(@PdhParseInstanceNameA <> nil);

    @PdhValidatePathW := GetProcAddress(DLLHandle,'PdhValidatePathW');
    Assert(@PdhValidatePathW <> nil);

    @PdhValidatePathA := GetProcAddress(DLLHandle,'PdhValidatePathA');
    Assert(@PdhValidatePathA <> nil);

    @PdhGetDefaultPerfObjectW := GetProcAddress(DLLHandle,'PdhGetDefaultPerfObjectW');
    Assert(@PdhGetDefaultPerfObjectW <> nil);

    @PdhGetDefaultPerfObjectA := GetProcAddress(DLLHandle,'PdhGetDefaultPerfObjectA');
    Assert(@PdhGetDefaultPerfObjectA <> nil);

    @PdhGetDefaultPerfCounterW := GetProcAddress(DLLHandle,'PdhGetDefaultPerfCounterW');
    Assert(@PdhGetDefaultPerfCounterW <> nil);

    @PdhGetDefaultPerfCounterA := GetProcAddress(DLLHandle,'PdhGetDefaultPerfCounterA');
    Assert(@PdhGetDefaultPerfCounterA <> nil);

    @PdhBrowseCountersW := GetProcAddress(DLLHandle,'PdhBrowseCountersW');
    Assert(@PdhBrowseCountersW <> nil);

    @PdhBrowseCountersA := GetProcAddress(DLLHandle,'PdhBrowseCountersA');
    Assert(@PdhBrowseCountersA <> nil);

    @PdhExpandCounterPathW := GetProcAddress(DLLHandle,'PdhExpandCounterPathW');
    Assert(@PdhExpandCounterPathW <> nil);

    @PdhExpandCounterPathA := GetProcAddress(DLLHandle,'PdhExpandCounterPathA');
    Assert(@PdhExpandCounterPathA <> nil);
  end
  else
  begin
    DLLLoaded := False;
    { Error: PDH.DLL could not be loaded !! }
  end;
{$IFNDEF MSDOS}
  SetErrorMode(ErrorMode)
{$ENDIF}
end {LoadDLL};

initialization
  LoadDLL;
end.
